#include <opnet.h>
#include <ema.h>
#include <opnet_emadefs.h>
#include <opnet_constants.h>



/* array for all textlist attributes in model */
VosT_Textlist*		tl_ptr [17];

/* array for all objects in model */
EmaT_Object_Id		obj [39];



main (argc, argv)
	int	argc;
	char	*argv[];
	{
	EmaT_Model_Id			model_id;
	int					i;

	/* initialize EMA package */
	Ema_Init (EMAC_MODE_ERR_PRINT);

	/* create an empty model */
	model_id = Ema_Model_Create (MOD_PROCESS);



	/* create all objects */
	obj [0] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [1] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [2] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [3] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [4] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [5] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [6] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [7] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [8] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [9] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [10] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [11] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [12] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [13] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [14] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [15] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [16] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [17] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [18] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [19] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [20] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [21] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [22] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [23] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [24] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [25] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [26] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [27] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [28] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [29] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [30] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [31] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [32] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [33] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [34] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [35] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [36] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [37] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [38] = Ema_Object_Create (model_id, OBJ_PR_POS);


	/* set the model level attributes */
	/* create and init textlist 'tl_ptr [0]' */
	tl_ptr [0] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [0], 
		"Objid    				\\my_id,\\ip_objid;",
		"int					\\net_num0, \\node_num0;",
		"int					\\net_num1, \\node_num1;",
		"int					\\net_num2, \\node_num2;",
		"int					\\net_num3, \\node_num3;",
		"int					\\net_num4, \\node_num4;",
		"int					\\query_sent[100][5],\\ngrp;",
		"double 					\\upd;",
		"ip_dgram_list*				\\igmp_list_ptr;",
		"int					\\grp_sent;",
		"int					\\n_links;",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [1]' */
	tl_ptr [1] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [1], 
		"int 			xx,disp,j,i,proto,ip_strm,in_strm,join,term,grp_id,data_len;",
		"Packet			*tmp_pk1,*tmp_pk2,*igmp_pkptr,*ip_pkptr,*decap_pkptr,*pkptr;",
		"int			*tmp_ptr;",
		"mc_id			*mc_table;",
		"int 			SEND_RESP,dest_node,src_net,src_node,Indep_Rou;",
		"Objid			sub_netid;",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [2]' */
	tl_ptr [2] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [2], 
		"#include \"ip_frag_sup.h\"",
		"",
		"#define ARRIVAL_FRM_IP                 op_intrpt_type () == OPC_INTRPT_STRM ",
		"#define UPD_INT                 ((op_intrpt_type () == OPC_INTRPT_SELF) && (op_intrpt_code () == 0))",
		"#define SH_INT                 ((op_intrpt_type () == OPC_INTRPT_SELF) && (op_intrpt_code () == 1))",
		"",
		"struct MC",
		"{  int interface[5];",
		"   int mtu[5];",
		"};",
		"typedef struct MC mc_id;",
		"",
		"struct MSHIP",
		"{  int me[20];",
		"};",
		"typedef struct MSHIP member;",
		"",
		"extern int IGMP;",
		"extern int UDP;",
		"",
		VOSC_EOL);

	Ema_Model_Attr_Set (model_id,
		"state vars",           COMP_CONTENTS, tl_ptr [0],
		"temp vars",            COMP_CONTENTS, tl_ptr [1],
		"header block",         COMP_CONTENTS, tl_ptr [2],
		EMAC_EOL);


	/* create model level attribute extensions */
	Ema_Model_Attr_Add (model_id, "NGRP", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Set (model_id,
		"NGRP",                 COMP_PROMOTE, EMAC_DISABLED,
		EMAC_EOL);



	/* assign attrs for object 'obj [0]' */
	/* create and init textlist 'tl_ptr [7]' */
	tl_ptr [7] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [7], 
		"grp_sent = 0;",
		"my_id = op_id_self();",
		"op_ima_obj_attr_get(my_id,\"NGRP\", &ngrp);",
		"ip_objid = op_topo_assoc (my_id, OPC_TOPO_ASSOC_OUT,OPC_OBJMTYPE_MODULE, 0);",
		" ",
		" /* Use the object id to get the address */",
		"op_ima_obj_attr_get (ip_objid, \"net_num0\", &net_num0);",
		"op_ima_obj_attr_get (ip_objid, \"node_num0\", &node_num0);",
		"op_ima_obj_attr_get (ip_objid, \"net_num1\", &net_num1);",
		"op_ima_obj_attr_get (ip_objid, \"node_num1\", &node_num1);",
		"op_ima_obj_attr_get (ip_objid, \"net_num2\", &net_num2);",
		"op_ima_obj_attr_get (ip_objid, \"node_num2\", &node_num2);",
		"op_ima_obj_attr_get (ip_objid, \"net_num3\", &net_num3);",
		"op_ima_obj_attr_get (ip_objid, \"node_num3\", &node_num3);",
		"op_ima_obj_attr_get (ip_objid, \"net_num4\", &net_num4);",
		"op_ima_obj_attr_get (ip_objid, \"node_num4\", &node_num4);",
		"op_ima_obj_attr_get (ip_objid, \"Indep_Rou\", &Indep_Rou); ",
		"op_intrpt_schedule_self(op_sim_time() + 6, 0);",
		"/*op_intrpt_schedule_self(op_sim_time() + 5.9, 1);*/",
		"for(i=0;i<100;++i){",
		"	for(j=0;j<5;++j)query_sent[i][j] = 0;",
		"};",
		"",
		"if(!Indep_Rou)sub_netid=op_topo_parent(op_topo_parent(ip_objid));",
		"   else sub_netid=op_topo_parent(ip_objid);",
		"n_links = op_topo_assoc_count(sub_netid,OPC_TOPO_ASSOC_IN,OPC_OBJTYPE_LKSIMP);",
		"printf(\"N-links at %d.%d = %d\\n\",net_num0,node_num0,n_links);",
		" ",
		"",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [0], 
		"name",                 COMP_CONTENTS, "init",
		"enter execs",          COMP_CONTENTS, tl_ptr [7],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [1],
		"initial",              COMP_TOGGLE,   EMAC_ENABLED,
		EMAC_EOL);


	/* assign attrs for object 'obj [1]' */
	Ema_Object_Attr_Set (model_id, obj [1], 
		"x",                    COMP_CONTENTS, (double) 90,
		"y",                    COMP_CONTENTS, (double) 210,
		EMAC_EOL);


	/* assign attrs for object 'obj [2]' */
	/* create and init textlist 'tl_ptr [9]' */
	tl_ptr [9] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [9], 
		"",
		"",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [2], 
		"name",                 COMP_CONTENTS, "idle",
		"enter execs",          COMP_CONTENTS, tl_ptr [9],
		"position",             COMP_CONTENTS, obj [3],
		EMAC_EOL);


	/* assign attrs for object 'obj [3]' */
	Ema_Object_Attr_Set (model_id, obj [3], 
		"x",                    COMP_CONTENTS, (double) 330,
		"y",                    COMP_CONTENTS, (double) 210,
		EMAC_EOL);


	/* assign attrs for object 'obj [4]' */
	/* create and init textlist 'tl_ptr [11]' */
	tl_ptr [11] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [11], 
		"in_strm = op_intrpt_strm();",
		"decap_pkptr = op_pk_get (in_strm);",
		"	op_pk_nfd_get(decap_pkptr,\"src_net\",&src_net);",
		"	op_pk_nfd_get(decap_pkptr,\"src_node\",&src_node);",
		"	  op_pk_nfd_get(decap_pkptr,\"strm\",&ip_strm);",
		"	  op_pk_nfd_get(decap_pkptr,\"prot_id\",&proto);",
		"	  op_pk_nfd_get(decap_pkptr,\"data\",&igmp_pkptr);",
		"	  op_pk_nfd_get(decap_pkptr,\"dest_node\",&dest_node);",
		"         op_pk_nfd_get(igmp_pkptr,\"terminate\",&term);",
		"         op_pk_nfd_get(igmp_pkptr,\"GRP_ID\",&grp_id);",
		"         op_pk_nfd_get(igmp_pkptr,\"join\",&join);",
		"",
		"	 if(proto != IGMP) op_sim_end(\"IGMP in router is getting the wrong pks\",\"\",\"\",\"\");",
		"         if(join == 1 && term == 0)",
		"	{/*printf(\"Got a join from %d.%d for grp %d at %d.%d\\n\",src_net,src_node,grp_id,net_num0,node_num0);*/",
		"	 mc_table = (mc_id *) op_ima_obj_svar_get(ip_objid,\"mc_table\");",
		"         query_sent[grp_id][ip_strm] = 0;",
		"	  mc_table[grp_id].interface[ip_strm] = 1;",
		"          op_pk_destroy(decap_pkptr);",
		"         op_pk_destroy(igmp_pkptr); /*later send it to QOSPF*/",
		"/*	printf(\"(%d.%d) Time: %f, OP(%d) member of grp %d came from %d.%d\\n\",net_num0,node_num0,op_sim_time(),ip_strm,grp_id,src_net,src_node); getchar();*/",
		"	}",
		"",
		"	else",
		"	{  if(dest_node == 500){",
		"		mc_table = (mc_id *) op_ima_obj_svar_get(ip_objid,\"mc_table\");",
		"		tmp_pk1 = op_pk_copy(igmp_pkptr) ; tmp_pk2 = op_pk_copy(decap_pkptr);",
		"		for(j=0;j< ngrp +1; j++){",
		"		igmp_pkptr =  op_pk_copy(tmp_pk1) ; decap_pkptr = op_pk_copy(tmp_pk2);",
		"		SEND_RESP = 0;",
		"		i = 0;",
		"		while(i < n_links + 1  && !SEND_RESP)",
		"		 { if(mc_table[j].interface[i] == 1 && i != ip_strm) SEND_RESP = 1;",
		"		   i++;",
		"		 }",
		"		if(src_net == net_num0 && src_node == node_num0) SEND_RESP = 0;",
		"		if(SEND_RESP){",
		"			op_pk_nfd_set(igmp_pkptr,\"join\",1);",
		"			op_pk_nfd_set(igmp_pkptr,\"terminate\",0);",
		"			op_pk_nfd_get(decap_pkptr,\"src_net\",&src_net);",
		"			op_pk_nfd_get(decap_pkptr,\"src_node\",&src_node);",
		"			op_pk_nfd_set(decap_pkptr,\"dest_net\",src_net);",
		"			op_pk_nfd_set(decap_pkptr,\"dest_node\",src_node);",
		"			op_pk_nfd_set(decap_pkptr,\"src_net\",net_num0);",
		"			op_pk_nfd_set(decap_pkptr,\"src_node\",node_num0);",
		"			op_pk_nfd_set(igmp_pkptr,\"GRP_ID\",j);",
		"			op_pk_nfd_set(decap_pkptr,\"data\",igmp_pkptr);",
		"                        op_pk_nfd_set(decap_pkptr,\"ttl\",2);",
		"/*			printf(\"Sending a join to %d.%d from %d.%d for grp %d\\n\",src_net,src_node,net_num0,node_num0,j); getchar();*/",
		"			op_pk_send(decap_pkptr,0);",
		"				     }",
		"		else { op_pk_destroy(decap_pkptr); op_pk_destroy(igmp_pkptr);}",
		"			}",
		"		op_pk_destroy(tmp_pk1);   op_pk_destroy(tmp_pk2);",
		"			}",
		"            else op_sim_end(\"Error in ROU_IGMP !!\",\"\",\"\",\"\");",
		"	 } ",
		"",
		"",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [12]' */
	tl_ptr [12] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [12], 
		"/*mc_table = (mc_id *) op_ima_obj_svar_get(ip_objid,\"mc_table\");",
		" ",
		"for(i=0;i<10;++i)",
		"  {  j=0;",
		"     while(j<5)",
		"        { if( mc_table[i].interface[j] == 1)",
		"                printf(\"Member of grp: %d on interface %d (%d.%d)\\n\",i,j,net_num0,node_num0);",
		"          j++;",
		"        }",
		"  }",
		"*/",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [4], 
		"name",                 COMP_CONTENTS, "FRM_IP",
		"enter execs",          COMP_CONTENTS, tl_ptr [11],
		"exit execs",           COMP_CONTENTS, tl_ptr [12],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [5],
		EMAC_EOL);


	/* assign attrs for object 'obj [5]' */
	Ema_Object_Attr_Set (model_id, obj [5], 
		"x",                    COMP_CONTENTS, (double) 330,
		"y",                    COMP_CONTENTS, (double) 390,
		EMAC_EOL);


	/* assign attrs for object 'obj [6]' */
	/* create and init textlist 'tl_ptr [13]' */
	tl_ptr [13] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [13], 
		"mc_table = (mc_id *) op_ima_obj_svar_get(ip_objid,\"mc_table\");",
		"disp = 0;",
		"i=0;",
		"	while(i < ngrp +1){",
		"             for(j=0;j < n_links+1;++j){",
		"			if(mc_table[i].interface[j] != 1)query_sent[i][j] == 0;",
		"			else query_sent[i][j]++;",
		"			if(query_sent[i][j] == 2 && mc_table[i].interface[j] == 1){",
		"				disp = 1;",
		"			printf(\"Tearing down for grp: %d on intrface %d at %d.%d\\n\",i,j,net_num0,node_num0);",
		"			    mc_table[i].interface[j] = 0;",
		"						}",
		"				}",
		"	i++;",
		"			  }",
		"              pkptr = op_pk_create_fmt(\"MC_APP_CNTRL\");",
		"              op_pk_nfd_set(pkptr,\"join\",0);",
		"              op_pk_nfd_set(pkptr,\"terminate\",0);",
		"              op_pk_nfd_set(pkptr,\"GRP_ID\",500);",
		" ",
		"              data_len = op_pk_total_size_get (pkptr) / 8;",
		"              ip_pkptr = op_pk_create_fmt (\"ip_dgram\");",
		"              op_pk_nfd_set (ip_pkptr, \"data\", pkptr);",
		" 	      op_pk_nfd_set (ip_pkptr, \"prot_id\", IGMP);",
		"              op_pk_bulk_size_set (ip_pkptr, data_len * 8);",
		" ",
		"              op_pk_nfd_set (ip_pkptr, \"dest_net\", 500);",
		"              op_pk_nfd_set (ip_pkptr, \"dest_node\", 500);",
		" ",
		"              /* Set the source address */",
		"              op_pk_nfd_set (ip_pkptr, \"src_net\", net_num0);",
		"              op_pk_nfd_set (ip_pkptr, \"src_node\", node_num0);",
		" ",
		"             /* set the length attributes of the IP packet. */",
		"              op_pk_nfd_set (ip_pkptr, \"orig_len\", data_len);",
		"              op_pk_nfd_set (ip_pkptr, \"frag_len\", data_len);",
		"	      op_pk_nfd_set (ip_pkptr, \"ttl\",2);",
		" ",
		"            /* Indicate that the packet is not yet fragmented. */",
		"              op_pk_nfd_set (ip_pkptr, \"frag\", 0);",
		"	       op_pk_send(ip_pkptr,0); ",
		" ",
		"op_intrpt_schedule_self(op_sim_time()+60,0);",
		"",
		"",
		"if(disp)",
		"{",
		"mc_table = (mc_id *) op_ima_obj_svar_get(ip_objid,\"mc_table\");",
		"printf(\"Time: %f		TEARING  IP Addr: %d.%d\\n\",op_sim_time(),net_num0,node_num0);",
		"printf(\"GRP   Interface   \\n\");",
		"for(i=0;i< ngrp+1;++i)",
		"  {  j=0;",
		"     while(j<5)",
		"        { if( mc_table[i].interface[j] == 1)",
		"                printf(\"%6d%12d\\n\",i,j);",
		"          j++;",
		"        }",
		"  }",
		"",
		"}",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [14]' */
	tl_ptr [14] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [14], 
		"/*mc_table = (mc_id *) op_ima_obj_svar_get(ip_objid,\"mc_table\");",
		"printf(\"%f:	GRP	Interface	IP Addr\\n\",op_sim_time()); ",
		"for(i=0;i<10;++i)",
		"  {  j=0;",
		"     while(j<5)",
		"        { if( mc_table[i].interface[j] == 1)",
		"                printf(\"   	%d	%d	(%d.%d)\\n\",i,j,net_num0,node_num0);",
		"          j++;",
		"        }",
		"  }",
		"getchar();*/",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [6], 
		"name",                 COMP_CONTENTS, "UPD",
		"enter execs",          COMP_CONTENTS, tl_ptr [13],
		"exit execs",           COMP_CONTENTS, tl_ptr [14],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [7],
		EMAC_EOL);


	/* assign attrs for object 'obj [7]' */
	Ema_Object_Attr_Set (model_id, obj [7], 
		"x",                    COMP_CONTENTS, (double) 510,
		"y",                    COMP_CONTENTS, (double) 210,
		EMAC_EOL);


	/* assign attrs for object 'obj [8]' */
	/* create and init textlist 'tl_ptr [15]' */
	tl_ptr [15] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [15], 
		"/*mc_table = (mc_id *) op_ima_obj_svar_get(ip_objid,\"mc_table\");",
		"printf(\"Time: %f                   JOINING Ip Addr: %d.%d\\n\",op_sim_time(),net_num0,node_num0);",
		"printf(\"GRP   Interface   \\n\");",
		"for(i=0;i< ngrp+1;++i)",
		"  {  j=0;",
		"     while(j<5)",
		"        { if( mc_table[i].interface[j] == 1)",
		"                printf(\"%6d%13d\\n\",i,j);",
		"          j++;",
		"        }",
		"  }",
		"getchar();",
		"*/",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [16]' */
	tl_ptr [16] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [16], 
		"op_intrpt_schedule_self(op_sim_time() + 60, 1);",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [8], 
		"name",                 COMP_CONTENTS, "dis",
		"enter execs",          COMP_CONTENTS, tl_ptr [15],
		"exit execs",           COMP_CONTENTS, tl_ptr [16],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [9],
		EMAC_EOL);


	/* assign attrs for object 'obj [9]' */
	Ema_Object_Attr_Set (model_id, obj [9], 
		"x",                    COMP_CONTENTS, (double) 330,
		"y",                    COMP_CONTENTS, (double) 90,
		EMAC_EOL);


	/* assign attrs for object 'obj [10]' */
	Ema_Object_Attr_Set (model_id, obj [10], 
		"name",                 COMP_CONTENTS, "tr_1",
		"condition",            COMP_CONTENTS, "ARRIVAL_FRM_IP",
		"dest state",           COMP_CONTENTS, obj [4],
		"src state",            COMP_CONTENTS, obj [2],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [11],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [12],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [13],
		"label pos",            COMP_CONTENTS, obj [14],
		EMAC_EOL);


	/* assign attrs for object 'obj [11]' */
	Ema_Object_Attr_Set (model_id, obj [11], 
		"x",                    COMP_CONTENTS, (double) 324,
		"y",                    COMP_CONTENTS, (double) 237,
		EMAC_EOL);


	/* assign attrs for object 'obj [12]' */
	Ema_Object_Attr_Set (model_id, obj [12], 
		"x",                    COMP_CONTENTS, (double) 285,
		"y",                    COMP_CONTENTS, (double) 289,
		EMAC_EOL);


	/* assign attrs for object 'obj [13]' */
	Ema_Object_Attr_Set (model_id, obj [13], 
		"x",                    COMP_CONTENTS, (double) 311,
		"y",                    COMP_CONTENTS, (double) 368,
		EMAC_EOL);


	/* assign attrs for object 'obj [14]' */
	Ema_Object_Attr_Set (model_id, obj [14], 
		"x",                    COMP_CONTENTS, (double) 296,
		"y",                    COMP_CONTENTS, (double) 258,
		EMAC_EOL);


	/* assign attrs for object 'obj [15]' */
	Ema_Object_Attr_Set (model_id, obj [15], 
		"name",                 COMP_CONTENTS, "tr_3",
		"dest state",           COMP_CONTENTS, obj [2],
		"src state",            COMP_CONTENTS, obj [4],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [16],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [17],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [18],
		"label pos",            COMP_CONTENTS, obj [19],
		EMAC_EOL);


	/* assign attrs for object 'obj [16]' */
	Ema_Object_Attr_Set (model_id, obj [16], 
		"x",                    COMP_CONTENTS, (double) 349,
		"y",                    COMP_CONTENTS, (double) 368,
		EMAC_EOL);


	/* assign attrs for object 'obj [17]' */
	Ema_Object_Attr_Set (model_id, obj [17], 
		"x",                    COMP_CONTENTS, (double) 393,
		"y",                    COMP_CONTENTS, (double) 302,
		EMAC_EOL);


	/* assign attrs for object 'obj [18]' */
	Ema_Object_Attr_Set (model_id, obj [18], 
		"x",                    COMP_CONTENTS, (double) 350,
		"y",                    COMP_CONTENTS, (double) 229,
		EMAC_EOL);


	/* assign attrs for object 'obj [19]' */
	Ema_Object_Attr_Set (model_id, obj [19], 
		"x",                    COMP_CONTENTS, (double) 371,
		"y",                    COMP_CONTENTS, (double) 335,
		EMAC_EOL);


	/* assign attrs for object 'obj [20]' */
	Ema_Object_Attr_Set (model_id, obj [20], 
		"name",                 COMP_CONTENTS, "tr_7",
		"condition",            COMP_CONTENTS, "UPD_INT",
		"dest state",           COMP_CONTENTS, obj [6],
		"src state",            COMP_CONTENTS, obj [2],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [21],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [22],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [23],
		"label pos",            COMP_CONTENTS, obj [24],
		EMAC_EOL);


	/* assign attrs for object 'obj [21]' */
	Ema_Object_Attr_Set (model_id, obj [21], 
		"x",                    COMP_CONTENTS, (double) 355,
		"y",                    COMP_CONTENTS, (double) 195,
		EMAC_EOL);


	/* assign attrs for object 'obj [22]' */
	Ema_Object_Attr_Set (model_id, obj [22], 
		"x",                    COMP_CONTENTS, (double) 414,
		"y",                    COMP_CONTENTS, (double) 177,
		EMAC_EOL);


	/* assign attrs for object 'obj [23]' */
	Ema_Object_Attr_Set (model_id, obj [23], 
		"x",                    COMP_CONTENTS, (double) 484,
		"y",                    COMP_CONTENTS, (double) 198,
		EMAC_EOL);


	/* assign attrs for object 'obj [24]' */
	Ema_Object_Attr_Set (model_id, obj [24], 
		"x",                    COMP_CONTENTS, (double) 384,
		"y",                    COMP_CONTENTS, (double) 186,
		EMAC_EOL);


	/* assign attrs for object 'obj [25]' */
	Ema_Object_Attr_Set (model_id, obj [25], 
		"name",                 COMP_CONTENTS, "tr_8",
		"dest state",           COMP_CONTENTS, obj [2],
		"src state",            COMP_CONTENTS, obj [6],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [26],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [27],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [28],
		"label pos",            COMP_CONTENTS, obj [29],
		EMAC_EOL);


	/* assign attrs for object 'obj [26]' */
	Ema_Object_Attr_Set (model_id, obj [26], 
		"x",                    COMP_CONTENTS, (double) 483,
		"y",                    COMP_CONTENTS, (double) 219,
		EMAC_EOL);


	/* assign attrs for object 'obj [27]' */
	Ema_Object_Attr_Set (model_id, obj [27], 
		"x",                    COMP_CONTENTS, (double) 402,
		"y",                    COMP_CONTENTS, (double) 245,
		EMAC_EOL);


	/* assign attrs for object 'obj [28]' */
	Ema_Object_Attr_Set (model_id, obj [28], 
		"x",                    COMP_CONTENTS, (double) 355,
		"y",                    COMP_CONTENTS, (double) 222,
		EMAC_EOL);


	/* assign attrs for object 'obj [29]' */
	Ema_Object_Attr_Set (model_id, obj [29], 
		"x",                    COMP_CONTENTS, (double) 442,
		"y",                    COMP_CONTENTS, (double) 232,
		EMAC_EOL);


	/* assign attrs for object 'obj [30]' */
	Ema_Object_Attr_Set (model_id, obj [30], 
		"name",                 COMP_CONTENTS, "tr_29",
		"dest state",           COMP_CONTENTS, obj [2],
		"src state",            COMP_CONTENTS, obj [8],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [31],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [32],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [33],
		"label pos",            COMP_CONTENTS, obj [34],
		EMAC_EOL);


	/* assign attrs for object 'obj [31]' */
	Ema_Object_Attr_Set (model_id, obj [31], 
		"x",                    COMP_CONTENTS, (double) 347,
		"y",                    COMP_CONTENTS, (double) 112,
		EMAC_EOL);


	/* assign attrs for object 'obj [32]' */
	Ema_Object_Attr_Set (model_id, obj [32], 
		"x",                    COMP_CONTENTS, (double) 360,
		"y",                    COMP_CONTENTS, (double) 148,
		EMAC_EOL);


	/* assign attrs for object 'obj [33]' */
	Ema_Object_Attr_Set (model_id, obj [33], 
		"x",                    COMP_CONTENTS, (double) 339,
		"y",                    COMP_CONTENTS, (double) 182,
		EMAC_EOL);


	/* assign attrs for object 'obj [34]' */
	Ema_Object_Attr_Set (model_id, obj [34], 
		"x",                    COMP_CONTENTS, (double) 353,
		"y",                    COMP_CONTENTS, (double) 130,
		EMAC_EOL);


	/* assign attrs for object 'obj [35]' */
	Ema_Object_Attr_Set (model_id, obj [35], 
		"name",                 COMP_CONTENTS, "tr_32",
		"dest state",           COMP_CONTENTS, obj [2],
		"src state",            COMP_CONTENTS, obj [0],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [36],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [37],
		"label pos",            COMP_CONTENTS, obj [38],
		EMAC_EOL);


	/* assign attrs for object 'obj [36]' */
	Ema_Object_Attr_Set (model_id, obj [36], 
		"x",                    COMP_CONTENTS, (double) 118,
		"y",                    COMP_CONTENTS, (double) 213,
		EMAC_EOL);


	/* assign attrs for object 'obj [37]' */
	Ema_Object_Attr_Set (model_id, obj [37], 
		"x",                    COMP_CONTENTS, (double) 302,
		"y",                    COMP_CONTENTS, (double) 213,
		EMAC_EOL);


	/* assign attrs for object 'obj [38]' */
	Ema_Object_Attr_Set (model_id, obj [38], 
		"x",                    COMP_CONTENTS, (double) 210,
		"y",                    COMP_CONTENTS, (double) 213,
		EMAC_EOL);








	/* write the model to application-readable form */
	Ema_Model_Write (model_id, "ROU_IGMP");

	}

